const {dialog, remote} = require('electron');
var serialPort = require('serialport');
var path = require('path');
var fs = require('fs');
var JSZip = require("jszip");
const { connect } = require('http2');
const log = require('electron-log');
const { info } = require('console');
var button_ok = "OK"
if(process.platform=="linux"){
    var BASE_PATH = path.join(process.env.HOME,"Documents/FM332Log");    
    var button_ok = "_OK_"
}
else if(process.platform=="darwin"){
    var BASE_PATH = path.join(process.env.HOME,"Documents/FM332Log");    
//var BASE_PATH = process.env.PWD;    
}
else{
    var BASE_PATH = process.env.PORTABLE_EXECUTABLE_DIR;
    
}
// var BASE_PATH = process.env.PORTABLE_EXECUTABLE_DIR;
if(BASE_PATH == null){
  BASE_PATH = __dirname;
}
var d = new Date(),
month = '' + (d.getMonth() + 1),
day = '' + d.getDate(),
year = d.getFullYear();
if (month.length < 2) month = '0' + month;
if (day.length < 2)  day = '0' + day;
var fileNameLog = [year, month, day].join('-')+"_log.log"
log.transports.file.resolvePath = () => BASE_PATH +"/logs/"+ fileNameLog;
log.transports.file.maxSize = 1024*1024*10;

var enumEtatTX = {
    GET_ADRESSES: 1,
    GET_DATA : 2,
    GET_DATE: 3,
    GET_DEVEUI : 4,
    ERASE: 5,
    SET_DATE: 6,
    GET_DATE_APP: 7,
    properties: {
      4: {text: "GET_DEVEUI", trame: "ATLDEVEUI=\r\n"},
      1: {text: "GET_ADRESSES", trame: "ATFGETADDRESS?\r\n"},
      3: {text: "GET_DATE", trame: "ATFGETDATE?\r\n"},
      5: {text: "ERASE", trame: "ATFERASEALL?\r\n"},
      6: {text: "SET_DATE", trame: "ATFSETDATE=\r\n"},
      7: {text: "GET_DATE_APP", trame: "ATFGETDATE?\r\n"}
    }
}
var ETAT_TX;
var SERIAL_PORT;
var BUFFER_RX = [];
var BUFFER_RX_2 = [];
var BUFFER_RX_DATE = [];
var BUFFER_RX_FLASH=[];
var BUFFER_RX_FLASH_TOT=[];
var BUFFER_RX_DEVEUI = [];
var BUFFER_RX_SETDATE = [];
var BUFFER_RX_ERASE = [];
var BUFFER_RX_GETDATEAPP = [];
var addressStart=0; //Address debut flash
var addressEnd=0; //Address fin flash
var addressLast=0;//Address de lecture en cours flash
var addressRead=0;
var nbOctetTotalFlash=0;
var cptNbTrameDataReceive=0
nbRemainingErase = null;
//Var globale
numBPR = null;
openedRecord=null;
dateBpr = null;
dateBprComponent=null;
comPort=null;
bDatafinished=false;
perCentProgressData=0;
bBprEmptyFlash=null; //booleen si il y' des données dans le bpr ou non
bComPortIsOpen = false;
bGetAddressConfig = false;
bAllFlashCollected = false;
bRecordsCreated = false;
var cptRecord = -1;
records=[];
recordsLogInfo=[];
//for loops
var i=0;
var j=0;
//For timeout
var cptSend = 0;
var MAX_SEND = 4;
var timeoutGetDeveui = null;
var timeoutGetDate = null;
var timeoutGetAddress = null;
var timeoutGetData = null;
var timeoutGetDateConfig = null;
var timeoutErase = null;
var timeoutSetDateConfig = null;
var bBprUnpluggedBeforeFin = false;

var dirNameExe = null;

function connectSerialPort(){
    comPort = null
    // log.info("in connect serial preload")
    serialPort.list().then(ports => {
        if(process.platform == "darwin"){
            for(var i = 0; i< ports.length; i++){                
                if(ports[i].manufacturer && ports[i].manufacturer.indexOf("FTDI") != -1 && ports[i].manufacturer.indexOf("PID_6015+DM") == -1){
                    log.info("PORT COM : ", ports[i].path)
                    comPort = ports[i].path;
                    // connectToPort(comPort);
                }
            }
        } 
        else{
            for(var i = 0; i< ports.length; i++){
                if(ports[i].pnpId && ports[i].pnpId.indexOf("FTDI") != -1 && ports[i].pnpId.indexOf("PID_6015+DM") == -1){
                    log.info(ports[i])
                    log.info("PORT COM : ", ports[i].path)
                    comPort = ports[i].path;
                    // connectToPort(comPort);
                }
            }
        }        
    });
}

function closeSerialPort(){
    //console.log("dans close serial ")

    SERIAL_PORT.close(function(error){
        if(error){
            bComPortIsOpen = false;
            log.error("ERROR closing PORT COM "+error);
        }
        else{
            bComPortIsOpen = false;
            log.info("CLOSE PORT COM OK ");
        }
    });
}
function connectToPort(COMPORT){
    //console.log("dans connect to port PRELOAD ")
    if(bComPortIsOpen == false){
        // console.log("dans if bComPortIsOpen == false de connectToPort PRELOAD")
        perCentProgressData=0;
        cptNbTrameDataReceive=0;
        bBprEmptyFlash = null;
        SERIAL_PORT = null;
        // BUFFER_RX_FLASH_TOT = [];
        //console.log("in connect to port preload : ", COMPORT)
        //Ouvertude du port COM
        var sp = new serialPort(COMPORT, {
            baudRate: 19200,
            dataBits: 8,
            parity: 'none',
            buffersize: 255,
            stopBits: 1,
            autoOpen : false
        });
        //console.log("sp : "+sp)
        sp.on('data', onData);
        SERIAL_PORT = sp;
        // if(!bComPortIsOpen){
        // console.log("dans connectToPort PRELOAD if bComPortIsOpen == false pour reopen serial")
        sp.open(function (error) {
            if (error) {
                // bComPortIsOpen = false
                // bBprUnpluggedBeforeFin = true
                log.error("ERROR OPENING PORT COM "+error);
            }
            else {
                bComPortIsOpen = true;
                log.info("Ouverture du port "+COMPORT+" OK");
                // ETAT_TX = enumEtatTX.GET_ADRESSES;
                ETAT_TX = enumEtatTX.GET_DEVEUI;
                processTX();
            }
        });
    }

    //initialize
    // numBpr = null;
    // bBprUnpluggedBeforeFin=false;

    // }

}

function processTX(){
    // ////console.log("process")
    BUFFER_RX = [];//On vide le buffer RX ici avant d'envoyer une autre trame
    switch(ETAT_TX){
        // case enumEtatTX.GET_ADRESSES:
        //     readDataFlashCreateRecords(SERIAL_PORT);
        // break;
        // case enumEtatTX.GET_DATE:
        //     getDateBprBegin(SERIAL_PORT);
        // break;
        case enumEtatTX.GET_DEVEUI:
            getDevEui(SERIAL_PORT);
        break;
    }
}

function onData(data){
    //console.log("in on data : ",data)
    cptSend = 0;
    bBprUnpluggedBeforeFin = false;
    switch(ETAT_TX){
        case enumEtatTX.GET_ADRESSES:
            clearTimeout(timeoutGetAddress);
            cptSend = 0;
            log.info("GET ADDRESSES FLASH")
            log.info(data)
            str_to_log_address = "";
            for (i = 0; i < data.length; i++) {
                BUFFER_RX.push(("00"+data[i].toString(16)).substr(-2).toUpperCase());
                BUFFER_RX_2.push(data[i])
                str_to_log_address += data[i]+" ";
            }
            // console.log("BUFFER_RX_2 : ", BUFFER_RX_2)
            if(BUFFER_RX.length == 29){
                //console.log("length buffer :  ", BUFFER_RX_2.length)
                addressStart = (BUFFER_RX_2[15]<<24)+(BUFFER_RX_2[16]<<16)+(BUFFER_RX_2[17]<<8)+BUFFER_RX_2[18]
                addressEnd = (BUFFER_RX_2[19]<<24)+(BUFFER_RX_2[20]<<16)+(BUFFER_RX_2[21]<<8)+BUFFER_RX_2[22]
                addressLast = (BUFFER_RX_2[23]<<24)+(BUFFER_RX_2[24]<<16)+(BUFFER_RX_2[25]<<8)+BUFFER_RX_2[26]
                addressRead = addressStart
                // addressStart = 58908
                // addressRead = 58908
                // console.log("addressStart : ",addressStart)
                log.info("addressLast : ",addressLast)
                if(addressLast < 0 || addressLast > addressEnd){
                    addressLast = addressEnd
                }
                // addressLast = 68000 //POPUR TEST
                //JUST FOR TEST
                var multipl = Math.ceil((addressLast - addressStart)/170)
                // console.log("multipl = ", multipl)
                if(multipl>0){
                    addressLast = (multipl)*170 + addressStart
                }
                // console.log("address last recalculated : ", addressLast)
                // addressLast = 66666
                // addressLast = 22698
                // console.log(addressEnd)
                if(addressStart == addressLast){
                    //console.log("if address start = address last")
                    perCentProgressData = 100
                    bBprEmptyFlash = true;
                    BUFFER_RX_2 = []
                    BUFFER_RX = []
                    if(bGetAddressConfig){
                        ETAT_TX = enumEtatTX.GET_DATE_APP
                        getDateBprComponent();
                    }
                    else{
                        ETAT_TX = null;
                    }
                    break;
                }
                else{
                    //console.log("dans else preload get adrrres on data ")
                    bBprEmptyFlash = false;
                    if(!bGetAddressConfig){
                        nbOctetTotalFlash = (parseInt((addressLast - addressStart)/170))*255
                        // console.log("nbOctetTotalFlash :", nbOctetTotalFlash)
                        log.info("OctetTotalFlash : ",(parseInt(((addressLast-2) - addressStart)/2))*3)
                        ETAT_TX = enumEtatTX.GET_DATA;
                        getDataFlashRecursiv(SERIAL_PORT);
                    }
                    else{
                        ETAT_TX = enumEtatTX.GET_DATE_APP
                        getDateBprComponent();
                    }
                    BUFFER_RX_2 = [];
                    BUFFER_RX = [];

                }

            }
            log.info(str_to_log_address);
        break;
        case enumEtatTX.GET_DATA:
            cptSend = 0;
            var step=0;
            var str_to_log = "";
            // log.info("GET FLASH DATA UNFORMATED")
            for (i = 0; i < data.length; i++) {
                BUFFER_RX_FLASH.push(data[i])
                BUFFER_RX_FLASH_TOT.push(data[i])
                str_to_log += data[i]+" ";
                if(BUFFER_RX_FLASH.length >= 255){//taille reponse pour une addresse donnee
                    // console.log("buffer length : ", BUFFER_RX_FLASH)
                    // console.log("buffer last val : ", BUFFER_RX_FLASH[BUFFER_RX_FLASH.length-1])
                    clearTimeout(timeoutGetData);
                    // i = data.length;
                    BUFFER_RX_FLASH=[]//On vide le buffer
                    addressRead+=170;
                    // console.log("addressRead : ",addressRead)
                    if(addressRead<addressLast && !bAllFlashCollected){
                        cptNbTrameDataReceive++;
                        perCentProgressData = Math.round((cptNbTrameDataReceive*255)/nbOctetTotalFlash * 100)
                        getDataFlashRecursiv(SERIAL_PORT)
                    }
                    // else{
                    //     console.log("eans else addRead < addressLast")
                    // }
                    // console.log("len buffer : ", BUFFER_RX_FLASH_TOT.length)
                    if(BUFFER_RX_FLASH_TOT.length >= nbOctetTotalFlash){//On a récupérer toute la flash
                        // console.log("recuperer tte la flash !!")
                        bAllFlashCollected =true;
                        ETAT_TX = null;
                        cptNbTrameDataReceive++;
                        perCentProgressData = Math.round((cptNbTrameDataReceive*255)/nbOctetTotalFlash*100)
                        // perCentProgressData = 100
                        // console.log("cptNbTrameDataReceive FIN % : ",Math.round((cptNbTrameDataReceive*255)/nbOctetTotalFlash *100))
                        detectRecords(SERIAL_PORT)
                    }
                    // else{
                    //     console.log("else BUFFER_RX_FLASH_TOT.length == nbOctetTotalFlash")
                    // }
                }
                // else{
                //     // console.log("")
                //     //DO something ?
                // }
            }
            log.info(str_to_log);
        break;
        case enumEtatTX.GET_DATE:
            //console.log("dans rx get date normal")
            clearTimeout(timeoutGetDate);
            cptSend = 0;
            //////console.log("data : ",data)
            for (i = 0; i < data.length; i++) {
                BUFFER_RX_DATE.push(data[i])
            }
            if(BUFFER_RX_DATE.length == 19){
                var dateBPR = new Date(BUFFER_RX_DATE[11]+2000,(BUFFER_RX_DATE[12]-1),BUFFER_RX_DATE[13],BUFFER_RX_DATE[14],BUFFER_RX_DATE[15],BUFFER_RX_DATE[16])
                BUFFER_RX_DATE=[]
                dateBpr = dateBPR
                //console.log("date dans get date normal : ", dateBpr)
                bprTimeReady = true
                ETAT_TX = null;
                // ETAT_TX = enumEtatTX.GET_DEVEUI;
                // getDevEui(SERIAL_PORT)
            }
        break;
        case enumEtatTX.GET_DEVEUI:
            //console.log("on data devEUI")
            clearTimeout(timeoutGetDeveui);
            //////console.log("data : ",data)
            cptSend = 0;
            for (i = 0; i < data.length; i++) {
                BUFFER_RX_DEVEUI.push((data[i].toString(16)).substr(-2).toUpperCase());
            }
            if(BUFFER_RX_DEVEUI.length == 20){
                numBPR=0;
                for(j=10;j<18;j++){
                    numBPR += BUFFER_RX_DEVEUI[j]
                }
                while(numBPR.charAt(0) === '0'){
                    numBPR = numBPR.substring(1);
                }
                log.info("DEVEUI : "+numBPR)
                // processRunning = false
                // ETAT_TX = enumEtatTX.GET_ADRESSES;
                ETAT_TX = enumEtatTX.GET_DATE;
                BUFFER_RX_DEVEUI=[];
                // readDataFlashCreateRecords(SERIAL_PORT);
                getDateBprBegin(SERIAL_PORT);
            }
        break;
        case enumEtatTX.SET_DATE:
            clearTimeout(timeoutSetDateConfig);
            //console.log("danbs on data SET DATE")
            //console.log("unplugged preload on data SET DATE : ", bBprUnpluggedBeforeFin)
            cptSend = 0;
            for (i = 0; i < data.length; i++) {
                BUFFER_RX_SETDATE.push(data[i]);
            }
            if(BUFFER_RX_SETDATE.length == 15){
                //console.log("dans if BUFFER_RX_SETDATE.length == 15")
                BUFFER_RX_SETDATE = []
                ETAT_TX = enumEtatTX.ERASE;
                erase(SERIAL_PORT)
            }
        break;
        case enumEtatTX.ERASE:
            clearTimeout(timeoutErase);
            // console.log("danbs on data erase")
            //console.log("unplugged preload on data erase : ", bBprUnpluggedBeforeFin)
            cptSend = 0;
            for (i = 0; i < data.length; i++) {
                BUFFER_RX_ERASE.push(data[i]);
            }
            // console.log("BUFFER_RX_ERASE : ", BUFFER_RX_ERASE)
            if(BUFFER_RX_ERASE.length >= 16){
                nbRemainingErase = BUFFER_RX_ERASE[12]<<8+BUFFER_RX_ERASE[13]
                // console.log("nbRemainingErase : ", nbRemainingErase)
                BUFFER_RX_ERASE=[];
                var messErase = "FM332Log n°"+numBPR+" has been configured. It is ready to use.\n"
                dialog.showMessageBox({title: "Flash erased",
                                    message: messErase,
                                    type: "info",
                                    buttons: [button_ok],})
                processRunning = false
                ETAT_TX = null;
            }
        break;
        case enumEtatTX.GET_DATE_APP:
        //console.log("ON DATA dans rx get date app component preload")
            clearTimeout(timeoutGetDateConfig);
            cptSend = 0;
            // ////console.log("dans rx get date app component preload")
            // ////console.log("data : ", data)
            // ////console.log("date component get ONDATA avant : ", dateBprComponent)
            for (i = 0; i < data.length; i++) {
                BUFFER_RX_GETDATEAPP.push(data[i])
            }
            if(BUFFER_RX_GETDATEAPP.length >= 19){
                // //console.log("BUFFER_RX_GETDATEAPP : ",BUFFER_RX_GETDATEAPP)

                var dateBPR = new Date(BUFFER_RX_GETDATEAPP[11]+2000,(BUFFER_RX_GETDATEAPP[12]-1),BUFFER_RX_GETDATEAPP[13],BUFFER_RX_GETDATEAPP[14],BUFFER_RX_GETDATEAPP[15],BUFFER_RX_GETDATEAPP[16])
                dateBprComponent = dateBPR
                // //console.log("date component get ONDATA apres : ", dateBprComponent)
                //console.log("date bpr config preload : ",dateBprComponent)
                ETAT_TX = null;
                BUFFER_RX_GETDATEAPP = [];//On vide le buffer
            }
        break;
    }
}

function readDataFlashCreateRecords(sp){
    // console.log("dans read data flash de preload")
    timeoutGetAddress = setTimeout(function(){
        cptSend++;
        if(cptSend >= MAX_SEND){
            cptSend = 0;
            //console.log("dans cptSend >= MAX_SEND")
            bBprUnpluggedBeforeFin = true;
            sp.close(function(err){
                if(err){
                    bComPortIsOpen = false;
                    //console.log("erreur close sp")
                }
                else{
                    bComPortIsOpen = false;
                    //console.log("close sp ok")
                }
            })
        }
        else{
            // bBprUnpluggedBeforeFin = false;
            readDataFlashCreateRecords(sp);
        }
    },1000);
    ETAT_TX = enumEtatTX.GET_ADRESSES;
    log.info(ETAT_TX)
    var to_send = Buffer.from("ATFGETADDRESS?\r\n", 'utf8')
    sp.write('0')
    sp.write(to_send, function (err, data) {
      if (err) {
        log.error("ERREUR WRITE ATFGETADDRESS" + err);
      } else {
        // bBprUnpluggedBeforeFin = false;
        log.info("Write ATFGETADDRESS OK");
      }
    });
}

function getDataFlashRecursiv(sp){
    // if(addressRead < addressLast){
        // //console.log("dans getDataFlashRecursiv debut ")
    timeoutGetData = setTimeout(function(){
        // //console.log("dans timeout de get data recursive")
        cptSend++;
        // //console.log("cptSend : ",cptSend)
        if(cptSend >= MAX_SEND){
            cptSend = 0;
            // console.log("dans cptSend >= MAX_SEND de getDataFlashRecursiv")
            bBprUnpluggedBeforeFin = true;
            sp.close(function(err){
                if(err){
                    bComPortIsOpen = false;
                    //console.log("erreur close sp de getDataFlashRecursiv : ",err)
                }
                else{
                    bComPortIsOpen = false;
                    //console.log("close sp ok getDataFlashRecursiv")
                }
            })
        }
        else{
            getDataFlashRecursiv(sp);
        }
    },500);
    ETAT_TX = enumEtatTX.GET_DATA;
    var addressReadToSend =  ("000000"+addressRead.toString()).substr(-6);
    // console.log("addressReadToSend : ",addressReadToSend)
    var to_send = Buffer.concat([Buffer.from("ATFGETROWDATA=", 'utf8'), Buffer.from(addressReadToSend, 'utf8'),new Buffer([0x0D,0x0A])]);
    sp.write('0')
    sp.write(to_send, function (err, data) {
        if (err) {
            // log.error("ERREUR WRITE ATFGETROWDATA" + err);
        }
        else {
            // bBprUnpluggedBeforeFin = false;
            // log.info("Write ATFGETROWDATA OK");
        }
    });
    // }
}

function detectRecords(sp){
    // console.log('in detect records')
    // log.info(BUFFER_RX_FLASH_TOT)
    var i;
    var newRecord = false;
    var record={
                bprNum:numBPR,
                name:'',
                typeCompteur:0,
                pasDeTemps:0,
                duration:0,
                dateRecord:new Date(),
                selected:true,
                p1m : [],
                dateTime : []
    };
    for(i=0;i<BUFFER_RX_FLASH_TOT.length;i++){
        if(i+1<BUFFER_RX_FLASH_TOT.length && BUFFER_RX_FLASH_TOT[i] == 255 && BUFFER_RX_FLASH_TOT[i+1] == 255){ //Fin des données il reste que des 255
            // console.log("fin des donnes reste que 255")
            record.duration = record.p1m.length
            records.push(record)
            ETAT_TX = null;
            bRecordsCreated = true;
            // getDate(sp)
            break;
        }
        if(i+4 < BUFFER_RX_FLASH_TOT.length && BUFFER_RX_FLASH_TOT[i]==254 && BUFFER_RX_FLASH_TOT[i+1]==12 && BUFFER_RX_FLASH_TOT[i+2]==1 && BUFFER_RX_FLASH_TOT[i+3]==253){
            cptRecord+=1;
            i+=4;
            newRecord = true
            console.log("IT'S A NEW RECORD")
        }
        if(cptRecord>-1){
            if(newRecord){
                if(cptRecord>0){
                    record.duration = record.p1m.length
                    records.push(record)
                    record={
                        bprNum:numBPR,
                        name:'',
                        typeCompteur:0,
                        pasDeTemps:0,
                        duration:0,
                        dateRecord:new Date(),
                        selected:true,
                        p1m : [],
                        dateTime : []
                    };
                }
                newRecord = false
                record.name = "Recording #"+(cptRecord+1)
                console.log("type compteur : "+BUFFER_RX_FLASH_TOT[i].toString(16))
                console.log("type compteur : "+BUFFER_RX_FLASH_TOT[i+1].toString(16))
                // console.log("type compteur : "+BUFFER_RX_FLASH_TOT[i].toString(16)=="31")
                // console.log("type compteur et pas de temps 2eme octet : "+BUFFER_RX_FLASH_TOT[i+1].toString(16))
                record.typeCompteur =  BUFFER_RX_FLASH_TOT[i++].toString(16) == '1' ? "meca" : "elec";
                // record.typeCompteur = BUFFER_RX_FLASH_TOT[i++]
                record.pasDeTemps = BUFFER_RX_FLASH_TOT[i++]
                //Faut gérer le pas de temps pour le moment on en a qu'un
                record.pasDeTemps = "1 min"
                record.dateRecord = new Date(BUFFER_RX_FLASH_TOT[i++]+2000,(BUFFER_RX_FLASH_TOT[i++]-1),BUFFER_RX_FLASH_TOT[i++],BUFFER_RX_FLASH_TOT[i++],
                                            BUFFER_RX_FLASH_TOT[i++],BUFFER_RX_FLASH_TOT[i++])
                record.dateRecord = new Date(record.dateRecord.getTime()-(9*60000)) //retirer les 9 min de decalage dans le bpr
                dateTime = record.dateRecord
            }
            record.p1m.push((BUFFER_RX_FLASH_TOT[i++]<<8)+BUFFER_RX_FLASH_TOT[i])
            record.dateTime.push(dateTime)
            dateTime = new Date(dateTime.getTime()+60000) //ajouter une minute
            if(i>=BUFFER_RX_FLASH_TOT.length-1){//dernier element du buffer
                record.duration = record.p1m.length
                records.push(record)
                ETAT_TX = null;
                bRecordsCreated = true;
                // getDate(sp)
                break;
            }
        }
    }
    bDatafinished = true;
    // BUFFER_RX_FLASH_TOT=[]
    log.info("records : ", records)
}

function getDateBprBegin(sp){
    //console.log("in call date")
    timeoutGetDate = setTimeout(function(){
        //console.log("in set timout get date begin ")
        cptSend++;
        if(cptSend >= MAX_SEND){
            cptSend = 0;
            // console.log("dans cptSend >= MAX_SEND de get date begin")
            bBprUnpluggedBeforeFin = true;
            sp.close(function(err){
                if(err){
                    //console.log("erreur close sp")
                }
                else{
                    bComPortIsOpen = false;
                    //console.log("close sp ok")
                }
            })
        }
        else{
            getDateBprBegin(sp);
        }
    },200);
    ETAT_TX = enumEtatTX.GET_DATE
    var to_send = Buffer.from("ATFGETDATE?\r\n", 'utf8')
    //console.log("var to send get date begin : ",to_send)
    sp.write('0')
    sp.write(to_send, function (err, data) {
      if (err) {
        log.error("ERREUR WRITE ATFGETDATE " + err);
      } else {
        log.info("Write ATFGETDATE OK");
      }
    });
}

function getDateBprComponent(){
    // console.log("dans getDateBprComponent")
    timeoutGetDateConfig = setTimeout(function(){
        cptSend++;
        if(cptSend >= MAX_SEND){
            cptSend = 0;
            bBprUnpluggedBeforeFin = true;
            //console.log("dans cptSend >= MAX_SEND")
            SERIAL_PORT.close(function(err){
                if(err){
                    bComPortIsOpen = false;
                    //console.log("erreur close sp")
                }
                else{
                    bComPortIsOpen = false;
                    //console.log("close sp ok")
                }
            })
        }
        else{
            getDateBprComponent();
        }
    },200);
    // if(bGetAddressConfig){
    //     ETAT_TX = enumEtatTX.GET_ADRESSES
    // }
    // else{
    ETAT_TX = enumEtatTX.GET_DATE_APP
    // }
    // dateBprComponent = null;
    ////console.log("in call date components")
    var to_send = Buffer.from("ATFGETDATE?\r\n", 'utf8')
    SERIAL_PORT.write('0')
    SERIAL_PORT.write('0')
    SERIAL_PORT.write(to_send, function (err, data) {
      if (err) {
        log.error("ERREUR WRITE ATFGETDATE Component " + err);
      } else {
        log.info("Write ATFGETDATE Component OK");
        // //console.log("date component getDateBprComponent : ", dateBprComponent)
      }
    });
}

function getDevEui(sp){
    // console.log("getdeveui PRELOAD")
    timeoutGetDeveui = setTimeout(function(){
        cptSend++;
        if(cptSend >= MAX_SEND){
            cptSend = 0;
            // console.log("dans cptSend >= MAX_SEND getdeveui")
            bBprUnpluggedBeforeFin = true;
            sp.close(function(err){
                if(err){
                    bComPortIsOpen = false;
                    // console.log("erreur close sp getdeveui")
                }
                else{
                    bComPortIsOpen = false;
                    // console.log("close sp ok getdeveui")
                }
            })
        }
        else{
            getDevEui(sp);
        }
    },200);
    var to_send = Buffer.from("ATLDEVEUI?\r\n", 'utf8')
    //console.log("to send DEVEUI: ", to_send)
    sp.write('0')
    sp.write(to_send, function (err, data) {
        if (err) {
            log.error("ERREUR WRITE ATLDEVEUI " + err);
        }
        else {
            bComPortIsOpen = true;
            log.info("Write OK ATLDEVEUI");
        }
    });
}

function erase(sp){
    //console.log("erase de PRELOAD function ")
    timeoutErase = setTimeout(function(){
        cptSend++;
        if(cptSend >= MAX_SEND){
            // console.log("dans cptSend >= MAX_SEND de ERASE ")
            bBprUnpluggedBeforeFin = true;
            cptSend = 0;
            ////console.log("dans cptSend >= MAX_SEND")
            sp.close(function(err){
                if(err){
                    bComPortIsOpen = false;
                    //console.log("erreur close sp")
                }
                else{
                    bComPortIsOpen = false;
                    //console.log("close sp ok")
                }
            })
        }
        else{
            erase(sp);
        }
    },200);
    var to_send = Buffer.from("ATFERASEALL?\r\n", 'utf8')
    ////console.log("ERASE ")
    sp.write('0')
    sp.write(to_send, function (err, data) {
        if (err) {
            log.error("ERREUR WRITE ATFERASEALL " + err);
        } else {
          clearTimeout(timeoutErase)
          log.info("Write ATFERASEALL OK");
        }
    });
}

function setDateBpr(){
    //console.log("set date bpr PRELOAD")
    timeoutSetDateConfig = setTimeout(function(){
        cptSend++;
        if(cptSend >= MAX_SEND){
            cptSend = 0;
            bBprUnpluggedBeforeFin = true;
            //console.log("dans cptSend >= MAX_SEND de send set date bpr ")
            SERIAL_PORT.close(function(err){
                if(err){
                    bComPortIsOpen = false;
                    //console.log("erreur close sp")
                }
                else{
                    bComPortIsOpen = false;
                    //console.log("close sp ok")
                }
            })
        }
        else{
            setDateBpr();
        }
    },200);
    ETAT_TX = enumEtatTX.SET_DATE;
    var now = new Date();
    var year = ("0" + now.getFullYear()).slice(-2);
    var month = ("0" + (now.getMonth() + 1)).slice(-2);
    var mday =  ("0" + now.getUTCDate()).slice(-2);
    var wday = ("0" + now.getDay()).slice(-2);
    var hour = ("0" + now.getHours()).slice(-2);
    var minute = ("0" + now.getMinutes()).slice(-2);
    var second =  ("0" + now.getSeconds()).slice(-2);
    var toSend = Buffer.concat([Buffer.from("ATFSETDATE=", 'utf8'), Buffer.from(year, 'utf8'), Buffer.from(month, 'utf8'), Buffer.from(mday, 'utf8'),
                  Buffer.from(wday.toString(), 'utf8'), Buffer.from(hour, 'utf8'), Buffer.from(minute, 'utf8'), Buffer.from(second, 'utf8'),new Buffer([0x0D,0x0A])]);
    // console.log("dans set date : ", now)
    SERIAL_PORT.write('0')
    SERIAL_PORT.write(toSend, function (err, data) {
      if (err) {
        log.error("ERREUR WRITE ATFSETDATE " + err);
      } else {
        log.info("Write ATFSETDATE OK");
        // sp.close();
      }
    });
}

function openFile(dir){
    // console.log("preload open file")
    // console.log("basepath : ", dirNameExe)
    // var openedRecord=null;
    var dirToSave = path.join(dir,"records")
    // console.log("dire to save : ", dirToSave)
    if(!fs.existsSync(dirToSave)){
        fs.mkdir(dirToSave , (err) => {
            if (err) {
                return console.error(err);
            }
        })
    }

    dialog.showOpenDialog({
        title: "Open Flud file",
        defaultPath: path.join(dirToSave),
        filters: [
            {
                name: "Flud file",
                extensions: ["flud2"]
            }
        ]
    }).then(file => {
        // console.log("open file path : ", path.join(path.dirname(remote.app.getPath('exe')), file.filePaths[0].replace(/^.*[\\\/]/, '')))
        // console.log("dir dans open : ", path.dirname(remote.app.getPath('exe')))
        if(!file.canceled){
            fs.readFile(path.join(file.filePaths[0]), 'binary', function (err, data) {
                if (err) throw err;
                openedRecord = JSON.parse(Buffer.from(data, 'base64').toString());
            })
        }
        else{
            openedRecord = '{}'
            log.warn("OPEN FILE Cancelled")

        }
    }).catch(err => {
        log.error("ERROR Open File : ",err)
    });
}

function saveInFiles(allRecords){
    // console.log("in save files ")
    var cptFileToSave=0;
    var cptCtrl = 0;
    var dirToSave = path.join(dirNameExe,"records")
    // console.log("dire to save : ", dirToSave)
    if(!fs.existsSync(dirToSave)){
        fs.mkdir(dirToSave , (err) => {
            if (err) {
                return console.error(err);
            }
        })
    }
    var zip = new JSZip();
    allRecords.forEach(function(record){
        if(record.selected){
            cptFileToSave++;
        }
    })
    allRecords.forEach(function(record){
        if(record.selected){
            cptCtrl++;
            var d = new Date(record.dateRecord),
            month = '' + (d.getMonth() + 1),
            day = '' + d.getDate(),
            year = d.getFullYear();
            if (month.length < 2) month = '0' + month;
            if (day.length < 2)  day = '0' + day;
            var fileNameSave = numBPR + "_" + record.name.replace(/\s/g, '') + "_" + [year, month, day].join('-') + ".flud2"
            fileNameSave = fileNameSave.replace('#', '')
            // console.log("filename save : ", fileNameSave)
            var buffer = new Buffer(JSON.stringify(record)).toString('base64')
            zip.file(fileNameSave, buffer)
        }
        if(cptCtrl === cptFileToSave){
            // console.log("dans cpt == pt")
            // console.log("path dirname : ", path.join(__dirname, "/test.zip"))
            // console.log("path dirname : ", path.join("./"))
            var d = new Date(),
            month = '' + (d.getMonth() + 1),
            day = '' + d.getDate(),
            year = d.getFullYear();
            if (month.length < 2) month = '0' + month;
            if (day.length < 2)  day = '0' + day;
            var fileNameSave = numBPR + "_" + [year, month, day].join('-')+".zip"
            fileNameSave = fileNameSave.replace('#', '')
            dialog.showSaveDialog({
                title: 'Save Records',
                defaultPath: path.join(dirToSave, fileNameSave),
                buttonLabel: 'Save',
                filters: [
                    {
                        name: 'Zip files',
                        extensions: ['zip']
                    },
                ],
                properties: []
            }).then(file => {
                // fs.mkdir(path.join(dirNameExe,"records"));
                // console.log("paaa : ",path.join(dirNameExe,"records") )
                // console.log('f path : ', path.join(__dirname, file.filePath.toString()))
                // console.log("name file : ", file.filePath.toString().replace(/^.*[\\\/]/, ''))
                if (!file.canceled) {
                    zip.generateNodeStream({type:'nodebuffer',streamFiles:true})
                    .pipe(fs.createWriteStream(path.join(file.filePath.toString())))
                    .on('finish', function () {
                        // JSZip generates a readable stream with a "end" event,
                        // but is piped here in a writable stream which emits a "finish" event.
                        // console.log("out.zip written.");
                        var optionDialog={title: 'FM332Log save', buttons: [button_ok],message: "Recording files are saved"}
                        dialog.showMessageBox(optionDialog)
                     });
                }
            }).catch(err => {
                log.error("ERROR SAVE FILES : ",err)
            });
        }
    });
}

function createCSVdata(rec, step, dateStartCsv, dateEndCsv){
    ////console.log("dans create csv preload")
    log.info("In create CSV data")
    var diffMins=0;
    var diffMinsStart=0;
    var p1m_tot_csv = [];
    var sum=0;
    var j=0
    var titre = "test"
    var dt=null;
    var formatedDateTimeCsv='';
    diffMins = Math.round((new Date(dateEndCsv)-new Date(dateStartCsv))/60000)
    diffMinsStart = Math.round((new Date(dateStartCsv)-new Date(rec.dateRecord))/60000)
    for(i=0;i<(diffMins);i+=step){
        for(j=0;j<step;j++){
            sum += rec.p1m[i+diffMinsStart+j]
        }
        dt = new Date((new Date(dateStartCsv).getTime())+(i*60000))
        formatedDateTimeCsv = dt.getFullYear() + "-" + ("00" + (dt.getMonth() + 1)).slice(-2) + "-" + ("00" + dt.getDate()).slice(-2) + " " +
                        ("00" + dt.getHours()).slice(-2) + ":" + ("00" + dt.getMinutes()).slice(-2) + ":" + ("00" + dt.getSeconds()).slice(-2);

        p1m_tot_csv[i] = [(new Date(dateStartCsv).getTime()/1000)+(i*60),formatedDateTimeCsv, sum/step]
        sum=0;
    }
    return p1m_tot_csv
}

function writeToCSVFile(record, step, start, end) {
    log.info("In write CSV file")
    var dirToSave = path.join(dirNameExe,"csv_export")
    // console.log("dire to OPEN : ", dirToSave)
    if(!fs.existsSync(dirToSave)){
        fs.mkdir(dirToSave , (err) => {
            if (err) {
                return log.error("ERROR Create folder for csv : ",err);
            }
        })
    }
    // fs.mkdir(dirToSave , (err) => {
    //     if (err) {
    //         return log.error("ERROR Create folder for csv : ",err);
    //     }
    // })
    var dStart = new Date(start),
    monthStart = '' + (dStart.getMonth() + 1),
    dayStart = '' + dStart.getDate(),
    yearStart = dStart.getFullYear();
    var dEnd = new Date(end),
    monthEnd = '' + (dEnd.getMonth() + 1),
    dayEnd = '' + dEnd.getDate(),
    yearEnd = dEnd.getFullYear();
    if (monthStart.length < 2) monthStart = '0' + monthStart;
    if (dayStart.length < 2)  dayStart = '0' + dayStart;
    if (monthEnd.length < 2) monthEnd = '0' + monthEnd;
    if (dayEnd.length < 2)  dayEnd = '0' + dayEnd;
    // if(numBPR){
    //     var fileNameSave = numBPR +"_"+record.name.replace(/\s/g, '') + "_" + [yearStart, monthStart, dayStart].join('-')+"_"+[yearEnd, monthEnd, dayEnd].join('-')+"_"+step+ "m.csv"
    // }
    // else{
    var fileNameSave = record.bprNum +"_"+record.name.replace(/\s/g, '') + "_" + [yearStart, monthStart, dayStart].join('-')+"_"+[yearEnd, monthEnd, dayEnd].join('-')+"_"+step+ "m.csv"
    // }
    
    fileNameSave = fileNameSave.replace('#', '')
    // console.log("filename save = ",fileNameSave)
    dialog.showSaveDialog({
        title: 'Save Record in File',
        defaultPath: path.join(dirToSave, fileNameSave),
        buttonLabel: 'Save',
        filters: [
            {
                name: 'CSV files',
                extensions: ['csv']
            },
        ],
        properties: []
    }).then(file => {
        // console.log("save csv location file : ", file.filePath.toString())
        // console.log("path.join(dirToSave,fileNameSave) : ", path.join(dirToSave,fileNameSave))
        if (!file.canceled) {
            var data = extractAsCSV(record, step, start, end)
            fs.writeFile(path.join(dirToSave,fileNameSave), data, err => {
            // fs.writeFile(path.join(file.filePath.toString(), fileNameSave), extractAsCSV(record, step, start, end), err => {
                if (err) {
                    // console.log("err")
                    log.error('Error writing to csv file', err);
                } else {
                    // console.log('saved');
                    var optionDialog={title: 'FM332Log export', buttons: [button_ok],message: "CSV file is saved"}
                    dialog.showMessageBox(optionDialog)
                }
            });
        }
    }).catch(err => {
        log.error("ERROR WRITE CSV : ", err)
    });
}

function extractAsCSV(record, step, start, end) {
    p1m_tot_csv = createCSVdata(record, step, start, end)
    let csvContent = "";
    p1m_tot_csv.unshift(['TS', 'DateTime', 'P']);
    p1m_tot_csv.forEach(function (rowArray) {
      let row = rowArray.join(";");
      csvContent += row + "\r\n";
    });
    return csvContent;
}

var preload =  {
    connectSerialPort: function(){
        connectSerialPort();
        bGetAddressConfig = false;
    },
    connectPortRunApp: function(cp){
        connectToPort(cp)
    },
    closeSerialPort: function(){
        closeSerialPort();
    },
    getIsSerialOpened: function(){
        return {'bSerialOpened':bComPortIsOpen}
    },
    getBprIsUnplugged: function(){
        return {'bBprUnplugged':bBprUnpluggedBeforeFin}
    },
    getAddressFlash: function(){
        // console.log("get adresse flash function")
        readDataFlashCreateRecords(SERIAL_PORT);
        bGetAddressConfig = true;
    },
    setBprIsUnplugged: function(bool){
        bBprUnpluggedBeforeFin = bool;
    },
    setBufferFlashTotEmpty: function(){
        BUFFER_RX_FLASH_TOT = [];
        BUFFER_RX_FLASH=[];
    },
    setRecordsEmpty: function(){
        records = [];
    },
    setNumBpr: function(d){
        numBPR= d;
    },
    setDateBprValue: function(n){
        dateBpr = n;
    },
    setNbRemainingErase: function(r){
        nbRemainingErase = r;
    },
    setPortCom: function(c){
        comPort = c;
    },
    reconnetPortCom: function(){
        connectSerialPort();
    },
    getPortCom: function(){
        return {'comPort':comPort}
    },
    setbComPortIsOpen: function(i){
        bComPortIsOpen = i;
    },
    setPerCentProgressData: function(num){
        perCentProgressData = num;
    },
    getBprIsEmpty: function(){
        return {'bBprEmpty':bBprEmptyFlash}
    },
    setBprIsEmpty: function(e){
        bBprEmptyFlash = e;
    },
    getVars: function(){
        return  {'comPort':comPort,
                'numBpr':numBPR,
                'dateBpr':dateBpr
                // 'records':records,
                // 'openedRecord':openedRecord
        }
    },
    setDateBpr: function(){
        setDateBpr();
    },
    getRemainingErase: function(){
        return {'nbRemainingErase':nbRemainingErase}
    },
    sendGetDataFlashBpr: function(){
        // console.log("send get data flash bpr function ")
        readDataFlashCreateRecords(SERIAL_PORT);
        bGetAddressConfig = false;
    },
    getPerCentProgressBar: function(){
        return {'perCentProgressData':perCentProgressData}
    },
    getRecords: function(){
        return {'records':records}
    },
    getDateBpr: function(){
        return {'dateBpr':dateBprComponent}
    },
    getAddressFlashIPC: function(){
        return {start:addressStart,end_flash: addressEnd,last: addressLast}
    },
    getDateBprBegin: function(){
        getDateBprBegin(SERIAL_PORT);
    },
    sendGetDateBpr: function(){
        // getDateBprComponent();
        // console.log("read data flash de send get date")
        readDataFlashCreateRecords(SERIAL_PORT);
        bGetAddressConfig = true;
        bBprEmpty = null;
        dateBprComponent = null;
    },
    sendGetDateBprAfterErase: function(){
        getDateBprComponent();
        // readDataFlashCreateRecords(SERIAL_PORT);
        // bGetAddressConfig = true;
        // bBprEmpty = null;
        dateBprComponent = null;
    },
    saveInFiles: function(allRecords, dir){
        dirNameExe = dir
        saveInFiles(allRecords);
    },
    openFile: function(dir){
        dirNameExe = dir
        openFile(dir);
    },
    getOpenedFile:function(){
        return {'openedRecord':openedRecord}
    },
    getRecordsCreated: function(){
        return {'bRecordsCreated':bRecordsCreated}
    },
    saveCSV: function(rec, step, start, end, dir){
        dirNameExe = dir
        writeToCSVFile(rec, step, start, end)
    }
}
module.exports = preload
